<?php
/*
Plugin Name: Print me!
Plugin URI: http://zelenin.me
Description: This plugin adds a print version
Version: 0.2
Author: Aleksandr Zelenin
Author URI: http://zelenin.me
License: Free
*/

if ( !$_GET['print'] == 1  ) {
	add_filter('the_content','printme_add_link');
}

function printme_add_link($content) {
	if ( is_singular() ) {
		$printme_options = get_option('printme_options');
		if ( empty( $printme_options['size'] ) ) {
			$size = 10;
		} else {
			$size = $printme_options['size'];
		}
		if ( empty( $printme_options['margin_v'] ) ) {
			$margin_v = 10;
		} else {
			$margin_v = $printme_options['margin_v'];
		}
		if ( empty( $printme_options['margin_h'] ) ) {
			$margin_h = 0;
		} else {
			$margin_h = $printme_options['margin_h'];
		}		
		if ( empty( $printme_options['print_text'] ) ) {
			$print_stub = '<img style="width:'. $size . 'px;height:'. $size .'px;" src="'. plugins_url('/printme.png', __FILE__) .'" title="print">';
		} else {
			$print_stub = $printme_options['print_text'];
		}
		wp_enqueue_script('jquery');
		wp_register_script('printme', plugins_url('/printme.js', __FILE__), false, '1', true);
		wp_enqueue_script('printme');
		$link = add_query_arg( 'print', '1', get_permalink() );
		$content = '<p style="margin:' . $margin_v . 'px ' . $margin_h . 'px;" id="print-page-link"><a href="' . $link . '">' . $print_stub . ' </a></p>'.$content;
		return $content;
	}
}

add_action('template_redirect', 'printme', 5);
function printme() {
	if ( $_GET["print"] == 1 ) {
		include(plugin_dir_path(__FILE__).'print.php');
		exit();
	}
}

add_action('admin_menu', 'printme_menu');
function printme_menu() {
	add_options_page('Print me!', 'Print me!', 'manage_options', 'printme', 'printme_options_page');
	add_filter( 'plugin_action_links', 'printme_options_links',10,2);
	function printme_options_links( $links, $file ) {
		if ( $file != plugin_basename( __FILE__ )) return $links;
		$settings_link = '<a href="options-general.php?page=printme">Settings</a>';
		array_unshift( $links, $settings_link );
		return $links;
	}
}

add_action( 'admin_init', 'printme_settings' );
function printme_settings() {
	register_setting( 'printme', 'printme_options'/*, 'printme_options_validate'*/ );
}

function printme_options_validate($inputs) {
	

}

function printme_options_page() { ?>
	<div class="wrap">
		<div class="icon32" id="icon-options-general"></div>
		<h2>Print me!</h2>
		<form method="post" action="options.php">
			<?php
				$printme_options = get_option('printme_options');
				settings_fields( 'printme' );
			?>
			<table class="form-table">
				<tbody>
					<tr valign="top">
						<th scope="row"><label for="printme_options[size]">Width/height of icon</label></th>
						<td><input type="text" class="regular-text code" value="<?php echo $printme_options['size']; ?>" id="printme_options[size]" name="printme_options[size]"> <span class="description">Insert width/height of icon (<=64)</span></td>
					</tr>
					<tr valign="top">
						<th scope="row"><label for="printme_options[margin_v]">Margin-top/margin-bottom</label></th>
						<td><input type="text" class="regular-text code" value="<?php echo $printme_options['margin_v']; ?>" id="printme_options[margin_v]" name="printme_options[margin_v]"> <span class="description">Insert margin-top/margin-bottom of icon</span></td>
					</tr>
					<tr valign="top">
						<th scope="row"><label for="printme_options[margin_h]">Margin-left/margin-right</label></th>
						<td><input type="text" class="regular-text code" value="<?php echo $printme_options['margin_h']; ?>" id="printme_options[margin_h]" name="printme_options[margin_h]"> <span class="description">Insert margin-left/margin-right of icon</span></td>
					</tr>
					<tr valign="top">
						<th scope="row"><label for="printme_options[print_text]">Text instead of icon</label></th>
						<td><input type="text" class="regular-text code" value="<?php echo $printme_options['print_text']; ?>" id="printme_options[print_text]" name="printme_options[print_text]"> <span class="description">Type text</span></td>
					</tr>
				</tbody>
			</table>
			<p class="submit"><input type="submit" class="button-primary" value="Update" /></p>
		</form>
	</div>
<?php } ?>